# -*- coding: utf-8 -*-
#
# lingo - basket and payment system
# Copyright (C) 2017  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import datetime
import logging

from django.core.management.base import BaseCommand
from django.utils import timezone

from combo.apps.lingo.models import BasketItem


class Command(BaseCommand):

    def handle(self, *args, **kwargs):
        logger = logging.getLogger(__name__)
        now = timezone.now()
        for item in BasketItem.objects.filter(
                notification_date__isnull=True,
                cancellation_date__isnull=True,
                payment_date__lt=now-datetime.timedelta(minutes=5),
                payment_date__gt=now-datetime.timedelta(minutes=300)):
            try:
                item.notify_payment()
            except:
                logger.exception('error in async notification for basket item %s', item.id)
